classification
Title: More failures found by pyfailmalloc
Type: crash Stage:
Components: Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: python-dev, skrah, vstinner
Priority: normal Keywords:

Created on 2013-10-29 18:24 by vstinner, last changed 2013-12-13 02:50 by vstinner. This issue is now closed.

Messages (17)
msg201649 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2013-10-29 18:24
Using pyfailamlloc, I found various bugs: see issue #18048. Because this issue has been closed, I'm opening a new issue for new bugs.

https://bitbucket.org/haypo/pyfailmalloc
msg201653 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-29 18:46
New changeset 1e5bbaed79ca by Victor Stinner in branch 'default':
Issue #19437: Fix Array_subscript() of ctypes, handle Array_item() failure
http://hg.python.org/cpython/rev/1e5bbaed79ca

New changeset fc825259ee86 by Victor Stinner in branch 'default':
Issue #19437: Fix convert_op_cmp() of decimal.Decimal rich comparator, handle
http://hg.python.org/cpython/rev/fc825259ee86

New changeset 6d57be1f19cf by Victor Stinner in branch 'default':
Issue #19437: Fix PyObject_CallFunction(), handle Py_VaBuildValue() and
http://hg.python.org/cpython/rev/6d57be1f19cf

New changeset 22ce0b7b1eaf by Victor Stinner in branch 'default':
Issue #19437: Fix _PyUnicode_New() (constructor of legacy string), set all
http://hg.python.org/cpython/rev/22ce0b7b1eaf
msg201660 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-29 19:36
New changeset 5acbdcfc21c9 by Victor Stinner in branch 'default':
Issue #19437: Fix dec_format() of the _decimal module, handle dec_strdup()
http://hg.python.org/cpython/rev/5acbdcfc21c9
msg201765 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-30 18:58
New changeset 7097b5c39db0 by Victor Stinner in branch 'default':
Issue #19437: Fix os.statvfs(), handle errors
http://hg.python.org/cpython/rev/7097b5c39db0

New changeset b49f9aa12dae by Victor Stinner in branch 'default':
Issue #19437: Fix select.epoll.poll(), fix code handling PyMem_New() error
http://hg.python.org/cpython/rev/b49f9aa12dae
msg201809 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-31 12:44
New changeset d191d22a9d23 by Victor Stinner in branch 'default':
Issue #19437: Fix _pickle, don't call _Unpickler_SkipConsumed() with an
http://hg.python.org/cpython/rev/d191d22a9d23
msg201828 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-10-31 16:23
New changeset 9b37fbda9043 by Victor Stinner in branch 'default':
Issue #19437: Fix get_filter() from _warnings, don't call PyObject_IsSubclass()
http://hg.python.org/cpython/rev/9b37fbda9043

New changeset e035b4656088 by Victor Stinner in branch 'default':
Issue #19437: Fix show_warning() of _warnings, stop at the first error to not
http://hg.python.org/cpython/rev/e035b4656088

New changeset 1181fcc02fe7 by Victor Stinner in branch 'default':
Issue #19437: Fix fill_and_set_sslerror() of _ssl, handle Py_BuildValue()
http://hg.python.org/cpython/rev/1181fcc02fe7

New changeset ae4bdd4b7240 by Victor Stinner in branch 'default':
Issue #19437: Fix PyCArrayType constructor, raise MemoryError on PyMem_Malloc()
http://hg.python.org/cpython/rev/ae4bdd4b7240

New changeset a0e2c2cb60f6 by Victor Stinner in branch 'default':
Issue #19437: Fix PyCFuncPtrType constructor, handle
http://hg.python.org/cpython/rev/a0e2c2cb60f6

New changeset 8f58e57e0d59 by Victor Stinner in branch 'default':
Issue #19437: Fix newPySSLSocket(), handle PyWeakref_NewRef() failure
http://hg.python.org/cpython/rev/8f58e57e0d59

New changeset 985f8762ee3e by Victor Stinner in branch 'default':
Issue #19437: Fix r_PyLong() of marshal module, stop immediatly at first
http://hg.python.org/cpython/rev/985f8762ee3e

New changeset 9e836a945ea9 by Victor Stinner in branch 'default':
Issue #19437: Fix r_object() of marshal module, handle r_byte() failure for
http://hg.python.org/cpython/rev/9e836a945ea9

New changeset fc54e2848c98 by Victor Stinner in branch 'default':
Issue #19437: Fix r_object() of marshal module, handle PyDict_SetItem() failure
http://hg.python.org/cpython/rev/fc54e2848c98

New changeset 995173ed248a by Victor Stinner in branch 'default':
Issue #19437: Cleanup r_ref() of the marshal module
http://hg.python.org/cpython/rev/995173ed248a
msg201895 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2013-11-01 13:23
Since this is tagged "crash", I'm curious if you managed to crash
_decimal.  The unhandled return in convert_op_cmp should result in
AtrributeError("object does not have a numerator attribute").

The exception that wasn't set in dec_format should result in a
wrong exception, but not a crash.
msg201908 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2013-11-01 14:47
I don't have the gdb trace anymore but it was really a crash.
msg201970 - (view) Author: Stefan Krah (skrah) * (Python committer) Date: 2013-11-02 12:34
Ok, I found it.  It was an assert() in debug mode that the MemoryError from
PyObject_IsInstance() was swallowed.  In production mode AttributeError
would have been raised.


Program received signal SIGABRT, Aborted.
0x00007ffff71e0475 in *__GI_raise (sig=<optimized out>) at ../nptl/sysdeps/unix/sysv/linux/raise.c:64
64      ../nptl/sysdeps/unix/sysv/linux/raise.c: No such file or directory.
(gdb)
(gdb) bt
#0  0x00007ffff71e0475 in *__GI_raise (sig=<optimized out>) at ../nptl/sysdeps/unix/sysv/linux/raise.c:64
#1  0x00007ffff71e36f0 in *__GI_abort () at abort.c:92
#2  0x00007ffff71d9621 in *__GI___assert_fail (assertion=0x688db8 "!PyErr_Occurred()", file=<optimized out>, line=1211,
    function=0x68a0c0 "PyEval_EvalFrameEx") at assert.c:81
#3  0x000000000058fe3a in PyEval_EvalFrameEx (f=0xb328d8, throwflag=0) at Python/ceval.c:1211
#4  0x00000000005a4192 in PyEval_EvalCodeEx (_co=0x7ffff05a3100, globals=0x7ffff0580d78, locals=0x0, args=0x7ffff059b288, argcount=1,
    kws=0x0, kwcount=0, defs=0x0, defcount=0, kwdefs=0x0, closure=0x0) at Python/ceval.c:3570
#5  0x0000000000650efa in function_call (func=0x7fffef54de00, arg=0x7ffff059b260, kw=0x0) at Objects/funcobject.c:632
#6  0x000000000045e2af in PyObject_Call (func=0x7fffef54de00, arg=0x7ffff059b260, kw=0x0) at Objects/abstract.c:2087
#7  0x000000000045f3ea in PyObject_CallFunctionObjArgs (callable=0x7fffef54de00) at Objects/abstract.c:2379
#8  0x000000000064b101 in property_descr_get (self=0x7fffef53cc58, obj=0x7ffff05a25a0, type=0xae3778) at Objects/descrobject.c:1345
#9  0x00000000004c27cd in _PyObject_GenericGetAttrWithDict (obj=0x7ffff05a25a0, name=0x7ffff7faf9e0, dict=0x0) at Objects/object.c:1181
#10 0x00000000004c2b9c in PyObject_GenericGetAttr (obj=0x7ffff05a25a0, name=0x7ffff7faf9e0) at Objects/object.c:1241
#11 0x00000000004c201e in PyObject_GetAttr (v=0x7ffff05a25a0, name=0x7ffff7faf9e0) at Objects/object.c:1015
#12 0x00000000004c1ba3 in PyObject_GetAttrString (v=0x7ffff05a25a0, name=0x7fffef275987 "numerator") at Objects/object.c:914
#13 0x00007fffef2319ec in numerator_as_decimal (r=0x7ffff05a25a0, context=0x7fffef1e6430)
    at /home/stefan/hg/master3/Modules/_decimal/_decimal.c:2951
#14 0x00007fffef231e4e in convert_op_cmp (vcmp=0x7fffffffc670, wcmp=0x7fffffffc668, v=0x7fffefea9760, w=0x7ffff05a25a0, op=0,
    context=0x7fffef1e6430) at /home/stefan/hg/master3/Modules/_decimal/_decimal.c:3013
#15 0x00007fffef23d10e in dec_richcompare (v=0x7fffefea9760, w=0x7ffff05a25a0, op=0)
msg202225 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-05 17:07
New changeset b93614f7ed83 by Victor Stinner in branch 'default':
Issue #19437: Fix pysqlite_cursor_iternext() of sqlite3, handle
http://hg.python.org/cpython/rev/b93614f7ed83

New changeset 00ee08fac522 by Victor Stinner in branch 'default':
Issue #19437: Fix pysqlite_connection_call() of sqlite3, return NULL when
http://hg.python.org/cpython/rev/00ee08fac522

New changeset 374635037b0a by Victor Stinner in branch 'default':
Issue #19437: Fix pysqlite_cursor_iternext() of sqlite3, when the row factory
http://hg.python.org/cpython/rev/374635037b0a

New changeset 35fdb15b4939 by Victor Stinner in branch 'default':
Issue #19437: Fix _threading.RLock constructor (rlock_new), call
http://hg.python.org/cpython/rev/35fdb15b4939

New changeset ea373a14f9e9 by Victor Stinner in branch 'default':
Issue #19437: Fix compiler_class(), handle compiler_lookup_arg() failure
http://hg.python.org/cpython/rev/ea373a14f9e9
msg202396 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-08 00:02
New changeset f2cd38795931 by Victor Stinner in branch 'default':
Issue #19437: Fix fsconvert_strdup(), raise a MemoryError on PyMem_Malloc()
http://hg.python.org/cpython/rev/f2cd38795931

New changeset f88c6417b9f6 by Victor Stinner in branch 'default':
Issue #19437: Fix _io._IOBase.close(), handle _PyObject_SetAttrId() failure
http://hg.python.org/cpython/rev/f88c6417b9f6

New changeset 0f48843652b1 by Victor Stinner in branch 'default':
Issue #19437: Fix datetime_subtract(), handle new_delta() failure
http://hg.python.org/cpython/rev/0f48843652b1
msg202444 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-08 20:14
New changeset 08c81db35959 by Victor Stinner in branch '3.3':
Issue #19437: Fix convert_op_cmp() of decimal.Decimal rich comparator, handle
http://hg.python.org/cpython/rev/08c81db35959

New changeset 3ff670a83c73 by Victor Stinner in branch '3.3':
Issue #19437: Fix dec_format() of the _decimal module, handle dec_strdup()
http://hg.python.org/cpython/rev/3ff670a83c73
msg202738 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-13 12:33
New changeset 8e40d07d3cd2 by Victor Stinner in branch 'default':
Issue #19437: Fix PyImport_ImportModuleLevelObject(), handle
http://hg.python.org/cpython/rev/8e40d07d3cd2

New changeset a217ea1671a8 by Victor Stinner in branch 'default':
Issue #19437: Fix PyCData_GetContainer() of ctypes, handle PyDict_New() failure
http://hg.python.org/cpython/rev/a217ea1671a8

New changeset dc5ae99bc605 by Victor Stinner in branch 'default':
Issue #19437: Fix GetKeepedObjects() of ctypes, handle PyCData_GetContainer()
http://hg.python.org/cpython/rev/dc5ae99bc605

New changeset 13203ea0ac5b by Victor Stinner in branch 'default':
Issue #19437: Fix ctypes, handle PyCData_GetContainer() and GetKeepedObjects()
http://hg.python.org/cpython/rev/13203ea0ac5b
msg202810 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-14 00:47
New changeset eea54395797c by Victor Stinner in branch 'default':
Issue #19437: Fix fold_unaryops_on_constants() of the peephole optimizer, clear
http://hg.python.org/cpython/rev/eea54395797c

New changeset 7d0323556c53 by Victor Stinner in branch 'default':
Issue #19437: Use an identifier for "__name__" string in pickle to improve
http://hg.python.org/cpython/rev/7d0323556c53

New changeset 285d28c3620a by Victor Stinner in branch 'default':
Issue #19437: Fix array.buffer_info(), handle PyLong_FromVoidPtr() and
http://hg.python.org/cpython/rev/285d28c3620a
msg202901 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-14 21:56
New changeset c9efe992e9b2 by Victor Stinner in branch 'default':
Issue #19437: Fix parse_save_field() of the csv module, handle PyList_Append()
http://hg.python.org/cpython/rev/c9efe992e9b2

New changeset 98ac18544722 by Victor Stinner in branch 'default':
Issue #19437: Fix parse_envlist() of the posix/nt module, don't call
http://hg.python.org/cpython/rev/98ac18544722

New changeset 61a712066770 by Victor Stinner in branch 'default':
Issue #19429, #19437: fix error handling in the OSError constructor
http://hg.python.org/cpython/rev/61a712066770

New changeset f7d401eaee0e by Victor Stinner in branch 'default':
Issue #19437: Fix init_builtin(), handle _PyImport_FindExtensionObject()
http://hg.python.org/cpython/rev/f7d401eaee0e
msg203311 - (view) Author: Roundup Robot (python-dev) (Python triager) Date: 2013-11-18 17:41
New changeset 8f770cdb7a19 by Victor Stinner in branch 'default':
Issue #19437: Fix error handling of CDataType_from_buffer()
http://hg.python.org/cpython/rev/8f770cdb7a19

New changeset 556bdd8d0dde by Victor Stinner in branch 'default':
Issue #19437: Fix error handling of PyCArrayType_new(), don't decreases the
http://hg.python.org/cpython/rev/556bdd8d0dde
msg206020 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2013-12-13 02:50
There is no more pending patches nor known issues, so I'm closing this issue. I will open a new issue if I find new bugs.
History
Date User Action Args
2013-12-13 02:50:22vstinnersetstatus: open -> closed
resolution: fixed
messages: + msg206020
2013-11-18 17:41:27python-devsetmessages: + msg203311
2013-11-14 21:56:33python-devsetmessages: + msg202901
2013-11-14 00:47:11python-devsetmessages: + msg202810
2013-11-13 12:33:27python-devsetmessages: + msg202738
2013-11-08 20:14:17python-devsetmessages: + msg202444
2013-11-08 00:02:30python-devsetmessages: + msg202396
2013-11-05 17:07:59python-devsetmessages: + msg202225
2013-11-02 12:34:12skrahsetmessages: + msg201970
2013-11-01 14:47:15vstinnersetmessages: + msg201908
2013-11-01 13:23:48skrahsetnosy: + skrah
messages: + msg201895
2013-10-31 16:23:52python-devsetmessages: + msg201828
2013-10-31 12:44:47python-devsetmessages: + msg201809
2013-10-30 18:58:52python-devsetmessages: + msg201765
2013-10-29 19:36:56python-devsetmessages: + msg201660
2013-10-29 18:46:10python-devsetnosy: + python-dev
messages: + msg201653
2013-10-29 18:24:07vstinnercreate